Thanks for contributing to this project!

To make the process as easy as possible, we've got a few guidelines that we'd appreciate you following:

## Filing Issues

Before you file an issue, please ensure that:

1. **It's a bug or a feature request** — if you're looking for help using MagicalRecord, please ask your question on [Stack Overflow](http://stackoverflow.com/). We monitor the [**MagicalRecord** tag](http://stackoverflow.com/questions/tagged/magicalrecord) so be sure to tag your question so that we see it
1. **Search for an existing issue** — there's a good chance you're not the only one experiencing the problem you've come to tell us about
2. **Include as much information as you can** — if we can't reproduce the problem you've filed, we can't fix it. Include crash logs, exception reports and code if you can.

## We Prefer Pull Requests

If you know exactly how to implement the feature being suggested or fix the bug being reported, please open a pull request instead of an issue. Pull requests are easier than patches or inline code blocks for discussing and merging the changes. Please ensure that you include tests in the Pull Request — we use XCTest with [Expecta](http://github.com/specta/expecta/).

If you can't make the change yourself, please open an issue after making sure that one isn't already logged.

## Contributing Code

Fork this repository, make some great changes (preferably in a branch named for the topic of the changes you're making) and send a pull request!

All code contributions should match our [coding conventions](https://github.com/magicalpanda/MagicalRecord/wiki/Coding-Conventions).

Thanks for reading the guidelines!
